###############################################################################
# @file instProg.mk
#
# @brief Generic driver installation/uninstallation program compilation.
#
# Automatically generated by driver-gen
#
# @author Copyright (C) 2003-2010 CERN. Yury GEORGIEVSKIY <ygeorgie@cern.ch>
#
# @date Created on 25/08/2009
#
# @section license_sec License
#          Released under the GPL
###############################################################################

include ../Makefile.base

# TODO. Should be position-independent
ROOTDIR := /acc/src/dsc/drivers/coht

# Installation program
INST_SRC_FILES := modinst.c utils.c

ifeq ("$(CPU)", "ppc4")
	INST_SRC_FILES += utils-lynx.c
else
	INST_SRC_FILES += utils-linux.c extra-linux.c
endif

INST_SRC_FILES := $(INST_SRC_FILES:%.c=%.$(CPU).o)

dgmodinst.$(CPU): $(INST_SRC_FILES)
	$(LD) $^  $(LOADLIBES) $(LDLIBS) -o $@

# Deinstallation program
DEINST_SRC_FILES = moduninst.c utils.c

ifeq ("$(CPU)", "ppc4")
	LDLIBS += /acc/sys/$(CPU)/lib/shlib/libdl.so
	DEINST_SRC_FILES += utils-lynx.c
else
	LDLIBS += -ldl
	DEINST_SRC_FILES += utils-linux.c extra-linux.c
endif

DEINST_SRC_FILES := $(DEINST_SRC_FILES:%.c=%.$(CPU).o)

dgmoduninst.$(CPU): $(DEINST_SRC_FILES)
	$(LD) $^  $(LOADLIBES) $(LDLIBS) -o $@


INCDIRS = \
	../<dg_string> \
	/acc/sys/$(CPU)/sys/include

ifeq ("$(CPU)", "ppc4")
	ADDINCLUDES = $(KERN_INCLUDES)
else
	ADDINCLUDES = -I$(ROOTDIR)
endif

EXEC_OBJS = dgmodinst.$(CPU) dgmoduninst.$(CPU)

# Move compiled files to proper place
move_objs:
	$(Q)mv $(sort $(INST_SRC_FILES) $(DEINST_SRC_FILES)) $(OBJDIR)

_build: $(EXEC_OBJS) $(OBJDIR) move_objs

linux:
	$(Q)$(MAKE) _build CPU=L865

lynx:
	$(Q)$(MAKE) _build CPU=ppc4

all:
	$(Q)$(MAKE) _build CPU=L865
	$(Q)$(MAKE) _build CPU=ppc4

# CERN delivery
include ./deliver.mk
deliver:
	$(Q)$(MAKE) _deliver $(filter $(strip $(ACCS)),$(MAKECMDGOALS)) CPU=L865
	$(Q)$(MAKE) _deliver $(filter $(strip $(ACCS)),$(MAKECMDGOALS)) CPU=ppc4

cleanloc clearloc:: abort
	@ if [ -n "$(ISP)" ]; then \
		rm -rf $(ISP)* ; \
	fi
	-rm modinst.$(CPU) moduninst.$(CPU)
	-find ./ -name '*~' | xargs rm -f
